diff --git a/src/iperf_client_api.c b/src/iperf_client_api.c
index 4d23b48b5..d72950f01 100644
--- a/src/iperf_client_api.c
+++ b/src/iperf_client_api.c
@@ -381,8 +381,8 @@ iperf_run_client(struct iperf_test * test)
 	    if (startup) {
 	        startup = 0;
 
-		// If the client is sending (normal mode) then set nonblocking sockets
-		if (!test->reverse) {
+		// Set non-blocking for non-UDP tests
+		if (test->protocol->id != Pudp) {
 		    SLIST_FOREACH(sp, &test->streams, streams) {
 			setnonblocking(sp->socket, 1);
 		    }
@@ -409,8 +409,8 @@ iperf_run_client(struct iperf_test * test)
 	         (test->settings->bytes != 0 && test->bytes_sent >= test->settings->bytes) ||
 	         (test->settings->blocks != 0 && test->blocks_sent >= test->settings->blocks))) {
 
-		// If the client is sending (normal mode) then undo nonblocking sockets
-		if (!test->reverse) {
+		// Set non-blocking for non-UDP tests
+		if (test->protocol->id != Pudp) {
 		    SLIST_FOREACH(sp, &test->streams, streams) {
 			setnonblocking(sp->socket, 0);
 		    }
diff --git a/src/iperf_server_api.c b/src/iperf_server_api.c
index dc331a6ea..a02fcbe1f 100644
--- a/src/iperf_server_api.c
+++ b/src/iperf_server_api.c
@@ -516,8 +516,8 @@ iperf_run_server(struct iperf_test *test)
 			    FD_SET(s, &test->read_set);
 			if (s > test->max_fd) test->max_fd = s;
 
-			// If the server is sending (reverse mode) then set nonblocking sockets
-			if (test->reverse) {
+			// If the protocol isn't UDP, set nonblocking sockets
+			if (test->protocol->id != Pudp) {
 			    setnonblocking(s, 1);
 			}
 
